import QtQuick 2.9
import QtQuick.Layouts 1.1
import QtQuick.Controls 2.5
import org.kde.plasma.components 2.0
import org.kde.plasma.core 2.1
import org.kde.plasma.plasmoid 2.0
 // gmail count widget   
Item
{
    id: root
    Layout.preferredWidth:  36
    Layout.maximumWidth:    48
    Layout.preferredHeight: 24
    Layout.maximumHeight:   36
    readonly property string emailCMD: "gtk-launch gmail"
    property double startTime: 0
    property int secondsElapsed: 0
    
    function timeChanged() {
        if(root.startTime==0)
        {          
            root.startTime = new Date().getTime(); //returns the number of milliseconds since the epoch (1970-01-01T00:00:00Z);

        }
    var currentTime = new Date().getTime();
    root.secondsElapsed = (currentTime-startTime)/1000;
    }
    
    function readEmailFile(fileUrl){  // read email count from file
       var xhr = new XMLHttpRequest;
       xhr.open("GET", fileUrl); // set Method and File
       xhr.onreadystatechange = function () {
           if(xhr.readyState === XMLHttpRequest.DONE){ // if request_status == DONE
               var response = xhr.responseText;
               count.email  = response;
           }
       }
       xhr.send(); // begin the request
   }

DataSource {
        id: executable
        engine: "executable"
        connectedSources: []
        property var callbacks: ({})
        onNewData: {
            var stdout = data["stdout"]

            if (callbacks[sourceName] !== undefined) {
                callbacks[sourceName](stdout);
            }

            exited(sourceName, stdout)
            disconnectSource(sourceName) // exec finished
        }

        function exec(cmd, onNewDataCallback) {
            if (onNewDataCallback !== undefined){
                callbacks[cmd] = onNewDataCallback
            }
            connectSource(cmd)
        }
        signal exited(string sourceName, string stdout)
    }

ToolButton {
    id: icon 
    Image {
        anchors.verticalCenter:parent.verticalCenter
        source:"mail-message"
        sourceSize.width: 22
        sourceSize.height: 22
    }
    onClicked: {
         // Qt.openUrlExternally("https://mail.google.com/mail/u/0/#inbox")
         executable.exec(emailCMD);
    }
}

 Text {
        id:count
        property var email:readEmailFile("/home/matt/.local/share/plasma/look-and-feel/DigiTech/contents/code/gmail.txt")
        bottomPadding:-30
        leftPadding:-10
        text:email
        color:"white"
        font.pointSize:12;
        anchors.left:icon.right
        anchors.top:icon.top
                
        Timer {
                id: readEmail             // timer to trigger update for email
                interval: 21 * 60 * 1000  // every 20 mins
                running: true
                repeat:  true
                onTriggered: {
                    root.startTime=0
                    readEmailFile("/tmp/gmail.txt")
                }
        }
        
        Timer{                  // timer to trigger update after wake from suspend mode
       id: suspend
       interval: 1000 ///delay timer for suspend to resume
       running: true
       repeat:  true
       onTriggered: {
                    root.timeChanged()
                    if (root.secondsElapsed > 1261) {
                        readEmailFile("/tmp/gmail.txt")
                    }
                }   
        }
    }
}
