import QtQuick 2.9
import org.kde.plasma.core 2.1
//import org.kde.plasma.extras 2.0
//import org.kde.plasma.plasmoid 2.0
import QtQuick.Layouts 1.1
import QtQuick.Controls 2.5
//import org.kde.kio 1.0 as Kio
import QtGraphicalEffects 1.15

Item {
    id:fullRep
    implicitHeight:380 // top.height+market.height+grid1.height *1.65 //330 * units.devicePixelRatio
    implicitWidth: 420 //title.width * units.devicePixelRatio * 1.7


    //GetData {id:jsonData}

   /// Kio.KRun { id: kRun }

    IconItem {
        id:refreshButton
        anchors.top:fullRep.top
        anchors.right:fullRep.right
        anchors.rightMargin:10
        anchors.topMargin:10
        source:"emblem-synchronizing-symbolic"
        width:24
        height:24
        smooth:true

        MouseArea {
            anchors.fill: parent
            onClicked:{
                jsonData.mdate=jsonData.getDate();
                jsonData.getData(jsonData.url1);
                jsonData.getData(jsonData.url2);
                jsonData.getData(jsonData.url3);
                jsonData.startTime=0; }
                cursorShape :Qt.PointingHandCursor
                hoverEnabled: true
                onEntered: refreshIconOverlay.color=Theme.viewHoverColor
                onExited: refreshIconOverlay.color=Theme.textColor
        }

        ColorOverlay {
            id:refreshIconOverlay
            anchors.fill: refreshButton
            source: refreshButton
            color: Theme.textColor
        }
    }

    RowLayout {
        id:titles
        spacing:10

        Image {
            id:icon
            source:"gmail.png"
            Layout.preferredWidth: 24
            Layout.preferredHeight: 24
            Layout.topMargin:10
            Layout.leftMargin:10
            smooth:true
        }

        Text {
            id:gmailTitle
            text:" G-Mail  -  New Messages:  "+jsonData.formatNumber(jsonData.count)
            font.pointSize:14
            antialiasing : true
            Layout.topMargin:5
            Layout.leftMargin:1
            color: Theme.textColor

            MouseArea {
                anchors.fill: parent
                hoverEnabled: true
                onEntered: gmailTitle.color=Theme.viewHoverColor
                onExited: gmailTitle.color=Theme.textColor
                onClicked:  Qt.openUrlExternally("https://mail.google.com/mail/u/0/#inbox") //kRun.openService("gmail")// Qt.openUrlExternally("https://mail.google.com/mail/u/0/#inbox")
                //kRun.openUrl("GMail")
                cursorShape :Qt.PointingHandCursor
            }
        }
    }

    ColumnLayout {
        id:marketSummary
        anchors.top:titles.bottom
        anchors.topMargin:10
        spacing:5

        Rectangle {
            id:ts
            implicitHeight: 1
            implicitWidth: fullRep.width*.95
            anchors.horizontalCenter:root.horizontalCenter
            Layout.leftMargin:10
            color: "gray"
            antialiasing : true
        }

        Text {
            id:summaryMarkets
            text:"Market Summary"
            font.pointSize:14
            color:Theme.textColor
            antialiasing : true;
            anchors.horizontalCenter:ts.horizontalCenter
            MouseArea {
                anchors.fill: parent
                onClicked: Qt.openUrlExternally("https://finance.yahoo.com/topic/stock-market-news/")
                cursorShape :Qt.PointingHandCursor
                hoverEnabled: true
                onEntered: summaryMarkets.color=Theme.viewHoverColor
                onExited: summaryMarkets.color=Theme.textColor
            }
        }

        Text {
            id:marketDate
            text:jsonData.mdate
            anchors.horizontalCenter:ts.horizontalCenter
            //Layout.alignment:Text.AlignHCenter
            font.pointSize:13
            color:Theme.textColor
            antialiasing : true;
        }

        Rectangle {
            id:ts2
            implicitWidth: fullRep.width*.95
            anchors.horizontalCenter:root.horizontalCenter
            Layout.leftMargin:10
            implicitHeight: 1
            color: "gray"
            antialiasing : true
        }

        Stocks{id:stocks}

        Rectangle {
            id:ts3
            implicitWidth: fullRep.width*.95
            anchors.horizontalCenter:root.horizontalCenter
            Layout.leftMargin:10
            Layout.bottomMargin:5
            implicitHeight: 1
            color: "gray"
            antialiasing : true
        }

        // Astros {id:astros}
        Scores {}
    }
}
