import QtQuick 2.9
import org.kde.plasma.core 2.1

Item {
    id:getjsonDataMain  // scripts to get json data
    property string symbols:"symbols=^DJI,^IXIC,^GSPC,CL=F,GC=F,^TNX"
    property string url1:"https://query1.finance.yahoo.com/v8/finance/spark?"+symbols+"&range=1d&interval=15m&indicators=close&includeTimestamps=false&includePrePost=false&corsDomain=finance.yahoo.com&.tsrc=finance&format=json"
    //https://query1.finance.yahoo.com/v8/finance/spark?symbols=^DJI,^IXIC,^GSPC,CL=F,GC=F,^TNX&range=1d&interval=15m&indicators=close&includeTimestamps=false&includePrePost=false&corsDomain=finance.yahoo.com&.tsrc=finance&format=json"
    property var finSymbols:["^DJI","^IXIC","^GSPC","CL=F","GC=F","^TNX"] //6
    property var finClose:[]
    property var finPrevClose:[]
    property string mdate:"1234"
    //property var curDate:Qt.formatDate(new Date(),"ddd")
    //property var curTime: Qt.formatTime(new Date(),"hh:mm")
    property var curDate:Qt.formatDate(checkTimer.data["Local"]["DateTime"],"ddd")
    property var curTime:Qt.formatTime(checkTimer.data["Local"]["DateTime"],"hh:mm")
    property var days:["Mon","Tue","Wed","Thu","Fri"]
    property var mstartTime:'08:35'
    property var mendTime:'15:30'

    property string url3:"/tmp/gmail.txt"
    property int count:0
    property double startTime: 0
    property int secondsElapsed: 0

    //property var url2:"https://site.api.espn.com/apis/site/v2/sports/baseball/mlb/scoreboard"
    property string url2:"https://site.api.espn.com/apis/site/v2/sports/basketball/nba/scoreboard"
   // property var url2:"/home/matt/Downloads/scoreboard.json"
    //property string favTeam:"Houston Astros"
    property string favTeam:"Houston Rockets"

    property int key:0
    property string gameStatusState:""
    property string gameStatusDetail:""
    property string gameStatusDescription:""
    property string gamePeriod:""
    property string gameClock:""
    property string gameDate:""
    property string gameHeadline:""
    property string gameboxScoresURL:""
    property string gamePlayoffRecord:""
    property string gameAltHeadline:""
    property string homeTeamName:""
    property string homeTeamAbrev:""
    property string homeTeamLogo:""
    property string homeTeamScore:""
    property string homeTeamRecord:""
    property string awayTeamName:""
    property string awayTeamAbrev:""
    property string awayTeamLogo:""
    property string awayTeamScore:""
    property string awayTeamRecord:""

    Component.onCompleted: {
        mdate=getDate();
        getData(url1);
        getData(url2);
        getData(url3);
    }

    function formatNumber(num) {
        return num.toString().replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1,')
    }

    function getData(url){  // get json data sources
        var xhr = new XMLHttpRequest;
        var scores={};
        var market={};
        xhr.open("GET", url); // set Method and File  true=asynchronous
        xhr.onreadystatechange = function () {
            if(xhr.readyState == 4){ // if request_status == DONE
                if (xhr.status == 200) {
                    var response = xhr.responseText;
                    if (url===url2) {
                        scores=JSON.parse(response);
                        processGameData(scores);
                        response=null;
                        scores=null;
                    }
                    else if (url===url1) {
                        market=JSON.parse(response);
                        processMarketData(market);
                        response=null;
                        market=null;
                    }
                    else if (url===url3) {
                        count=response;
                        response=null;
                    }
                }
            }
        return null
        }
        xhr.send(); // begin the request
        return null
    }

    function processGameData (scores) {
         if (typeof(scores) != "undefined") {

            for (var i = 0; i < Object.keys(scores.events).length; i++) {

                if (scores.events[i].competitions[0].competitors[0].team.displayName===favTeam)  {
                    key=i;
                    break;
                }
                else if (scores.events[i].competitions[0].competitors[1].team.displayName===favTeam)  {
                    key=i;
                    break;
                }
                key=0; // else no fav team game, pick first available game.
            }

            gameStatusState=scores.events[key].competitions[0].status.type.state;
            gameStatusDetail=scores.events[key].competitions[0].status.type.detail;
            gameStatusDescription=scores.events[key].competitions[0].status.type.description;
            gamePeriod=scores.events[key].competitions[0].status.period;
            gameClock=scores.events[key].competitions[0].status.displayClock;
            gameDate=scores.events[key].competitions[0].date;
            gamePlayoffRecord=scores.events[key].competitions[0].hasOwnProperty("series") ? scores.events[key].competitions[0].series.summary:""
            gameAltHeadline=(typeof scores.events[key].competitions[0].notes[0]!="undefined") ? scores.events[key].competitions[0].notes[0].headline : ""
            gameHeadline=scores.events[key].competitions[0].hasOwnProperty("headlines") ? scores.events[key].competitions[0].headlines[0].shortLinkText : gameAltHeadline+"    "+gamePlayoffRecord
            //gameHeadline=scores.events[key].competitions[0].hasOwnProperty("headlines") ? scores.events[key].competitions[0].headlines[0].shortLinkText : ""
            gameboxScoresURL=scores.events[key].links[0].href;
            homeTeamName=scores.events[key].competitions[0].competitors[0].team.displayName;
            homeTeamAbrev=scores.events[key].competitions[0].competitors[0].team.abbreviation;
            homeTeamLogo=scores.events[key].competitions[0].competitors[0].team.logo;
            homeTeamScore=scores.events[key].competitions[0].competitors[0].score;
            homeTeamRecord=scores.events[key].competitions[0].competitors[0].records[0].summary;
            awayTeamName=scores.events[key].competitions[0].competitors[1].team.displayName;
            awayTeamAbrev=scores.events[key].competitions[0].competitors[1].team.abbreviation;
            awayTeamLogo=scores.events[key].competitions[0].competitors[1].team.logo;
            awayTeamScore=scores.events[key].competitions[0].competitors[1].score;
            awayTeamRecord=scores.events[key].competitions[0].competitors[1].records[0].summary;
         }
        scores=null;
        return null;
    }

    function processMarketData (mkt) {

         if (typeof(mkt) != "undefined") {
            var x1=[];
            var y1=[];
            x1[0]=mkt[finSymbols[0]].close.slice(-1)[0]!=null ? mkt[finSymbols[0]].close.slice(-1)[0].toFixed(2):mkt[finSymbols[0]].close.slice(-2)[0].toFixed(2);
            x1[1]=mkt[finSymbols[1]].close.slice(-1)[0]!=null ? mkt[finSymbols[1]].close.slice(-1)[0].toFixed(2):mkt[finSymbols[1]].close.slice(-2)[0].toFixed(2);
            x1[2]=mkt[finSymbols[2]].close.slice(-1)[0]!=null ? mkt[finSymbols[2]].close.slice(-1)[0].toFixed(2):mkt[finSymbols[2]].close.slice(-2)[0].toFixed(2);
            x1[3]=mkt[finSymbols[3]].close!=null ? mkt[finSymbols[3]].close.slice(-1)[0].toFixed(2):mkt[finSymbols[3]].previousClose.toFixed(2);
            x1[4]=mkt[finSymbols[4]].close!=null ? mkt[finSymbols[4]].close.slice(-1)[0].toFixed(2):mkt[finSymbols[4]].previousClose.toFixed(2);
            x1[5]=mkt[finSymbols[5]].close!=null ? mkt[finSymbols[5]].close.slice(-1)[0].toFixed(2):mkt[finSymbols[5]].previousClose.toFixed(2);
            finClose=x1;
            y1[0]=mkt[finSymbols[0]].previousClose.toFixed(2);
            y1[1]=mkt[finSymbols[1]].previousClose.toFixed(2);
            y1[2]=mkt[finSymbols[2]].previousClose.toFixed(2);
            y1[3]=mkt[finSymbols[3]].previousClose.toFixed(2);
            y1[4]=mkt[finSymbols[4]].previousClose.toFixed(2);
            y1[5]=mkt[finSymbols[5]].previousClose.toFixed(2);
            finPrevClose=y1;
         }
        x1=null;
        y1=null;
        mkt=null;
        return null;
    }

    function getOrdinal(n) {            // assigns superfix to inning
        var s=["th","st","nd","rd"],
        v=n%100;
        return (s[(v-20)%10]||s[v]||s[0]);
    }

    function gameState() {
        if (gameStatusState == "pre") {
            return (Qt.formatDateTime(new Date(gameDate),"h:mm ap"));
        }
        else if (gameStatusState == "in") {
            if (gameStatusDescription!="In Progress") {
                return (gameStatusDetail);
            }
            return (gamePeriod+getOrdinal(gamePeriod));
        }
        else {
            return (gameStatusDetail);
        }
    }

    function getDate () {
        let today=new Date().toLocaleString("dd/mm/yy");
        return today
    }

    function checkDate() {  // check if market is open hours/days
        //curDate=Qt.formatDate(new Date(),"ddd");
        //curTime=Qt.formatTime(new Date(),"hh:mm");
        return (curTime > mstartTime && curTime < mendTime) && days.includes(curDate)
    }

    function timeChanged() {  // check if wake from sleep mode, time greater than 20mins, normal timer
        if(startTime==0)
        {
            startTime = new Date().getTime(); //returns the number of milliseconds since the epoch (1970-01-01T00:00:00Z);
        }
        var currentTime = new Date().getTime();
        secondsElapsed = (currentTime-startTime)/1000;
        return secondsElapsed
    }

    function gameInterval () {
        if (gameStatusState == "pre") {
             if (Math.abs((Qt.formatDateTime(checkTimer.data["Local"]["DateTime"],"hhmm")-Qt.formatDateTime(new Date(gameDate),"hhmm"))) < 2) {
                 // less than 5 mins to game start time
                return 20*60*1000;
            }
        return 2*60*60*1000;
        }
        if (gameStatusState == "in") {
            if (gameStatusDetail=="Delayed") { // game delayed check again in 1:15 //
                 return 1*75*60*1000;
            }
            return 20*60*1000;
        }
        if (gameStatusState == "post") {
            return 8*60*60*1000;
        }
        return  2*60*60*1000;// default 2 hours if nothing matched
    }

    property var dataTimer:Timer {                  // timer to trigger update refresh data
        interval: 20 * 60 * 1000 // every 20 minutes
        running: true
        repeat:  true
        triggeredOnStart:false
        onTriggered: {
            getData(url3);
            startTime=0;
            if (checkDate()) {
                gatData(url1);
                mdate=getDate();
            }
        }
    }

    property var gameTimer: Timer {
        interval: gameInterval()
        running:true
        repeat:true
        triggeredOnStart:false
        onTriggered:getData(url2)
    }

    property var suspendTimer:Timer{        // timer to trigger update after wake from suspend mode
        interval: 21*1000                  // delay 20 secs for suspend to resume
        running: false
        repeat:  false
        triggeredOnStart:false
        onTriggered: {
            mdate=getDate();
            getData(url1);
            getData(url2);
            getData(url3);
            dataTimer.restart();
            gameTimer.restart();
            startTime=0;
        }
    }

    DataSource {
        id: checkTimer  // use system clock for wake from suspend check
        engine: "time"
        connectedSources: ["Local"]
        interval: 995
        onNewData:{
            timeChanged()>1210 ?  suspendTimer.start():suspendTimer.stop()
        }
    }

    //Text {
    //    text: gameInterval()
      //  color:"black"
   // }
}
