import QtQuick 2.9
import QtQuick.Controls 2.15
import org.kde.plasma.components 2.0
import org.kde.plasma.core 2.1
import QtQuick.Layouts 1.15

//astros mlb scores

Item {
    id:root
    width:500
    height:125
    property var url1:"http://site.api.espn.com/apis/site/v2/sports/basketball/nba/scoreboard"
    //property var url2:"http://site.api.espn.com/apis/site/v2/sports/baseball/mlb/teams"
    //sports.leagues.teams
    property var scores:{}
    property var key:0
    /// Object.keys(index.events).length  // array size

    function getOrdinal(n) {            // assigns superfix to date
        var s=["th","st","nd","rd"],
        v=n%100;
        return (s[(v-20)%10]||s[v]||s[0]);
    }

    function getData(url){  // get data json api scores
        var xhr = new XMLHttpRequest;
        xhr.open("GET", url); // set Method and File  true=asynchronous
        xhr.onreadystatechange = function () {
            if(xhr.readyState == 4){ // if request_status == DONE
                if (xhr.status == 200) {
                    var response = xhr.responseText;
                    scores=JSON.parse(response)
                }
            }
        }
        xhr.send(); // begin the request
    }

    Component.onCompleted: {
        getData(url1); // first run reboot get data
    }
    function findKey() {  // find astros

        for (var i = 0; i < Object.keys(scores.events).length; i++) {

            if (scores.events[i].competitions[0].competitors[0].team.displayName==="Houston Rockets")  {
                key=i
                break;
            }
            else if (scores.events[i].competitions[0].competitors[1].team.displayName==="Houston Rockets")  {
                key=i
                break;
            }
        }
    }

    Column {
        Rectangle {
            width:root.width*.83
            height:65
            antialiasing : true
            color:"transparent"
            border.color:"transparent"
            radius:8

            MouseArea {
                id: mouseArea1a
                anchors.fill: parent
                cursorShape:  Qt.PointingHandCursor
                hoverEnabled:true
                acceptedButtons: Qt.LeftButton | Qt.MiddleButton
                onEntered:parent.border.color=Theme.viewHoverColor
                onExited:parent.border.color="transparent"
                onClicked: {
                    if (mouse.button == Qt.MiddleButton) {
                        getData(url1);
                        initTimer.start()
                    }
                    else {
                        Qt.openUrlExternally(scores.events[key].links[0].href)

                    }
                }
            }
        }

        Row {
            id:game
            spacing:10
            topPadding:10
            leftPadding:15

            Image {
                source:scores.events[key].competitions[0].competitors[1].team.logo
                width:48
                height:48
                cache:false
                smooth:true
            }
            Text {
                id:awayTeam
                text:scores.events[key].competitions[0].competitors[1].team.abbreviation
                color:Theme.textColor
                antialiasing : true
                font.pointSize:16
                width:40
                Layout.fillWidth:true

                Text {
                    id:awayTeamRecord
                    text:"("+scores.events[key].competitions[0].competitors[1].records[0].summary+")"
                    color:"gray"
                    font.pointSize:10
                    antialiasing : true
                    anchors.top:parent.bottom
                    anchors.horizontalCenter:parent.horizontalCenter
                }
            }

            Text {
                id:awayTeamScore
                text:scores.events[key].competitions[0].competitors[1].score
                color:Theme.textColor
                antialiasing : true
                font.pointSize:16
                width:60
                Layout.fillWidth:true
            }

            Text {
                id:gameStatus
                text:gameState()
                color:Theme.textColor
                antialiasing : true
                font.pointSize:12
                topPadding:5
                //leftPadding:15
                //width:scores.events[key].competitions[0].status.type.state == "pre" ? 60: 35
               // width:gameState().length > 10  ? 60 : 40
                width:35
                Layout.fillWidth:true

                Text {
                    id:gameTime
                    text:Qt.formatDateTime(new Date(scores.events[key].competitions[0].date),"M/dd/yy")
                    color:"gray"
                    antialiasing : true
                    font.pointSize:10
                    anchors.top:parent.bottom
                    anchors.horizontalCenter:parent.horizontalCenter
                }
            }

            Text {
                text:""         //spacer
                width:20
                Layout.fillWidth:true
            }

            Image {
                id:homeTeamLogo
                source:scores.events[key].competitions[0].competitors[0].team.logo
                width:42
                height:42
                cache:false
                smooth:true
            }
            Text {
                id:homeTeam
                text:scores.events[key].competitions[0].competitors[0].team.abbreviation
                color:Theme.textColor
                font.pointSize:16
                antialiasing : true

                Text {
                    id:homeTeamRecord
                    text:"("+scores.events[key].competitions[0].competitors[0].records[0].summary+")"
                    color:"gray"
                    antialiasing : true
                    font.pointSize:10
                    anchors.top:parent.bottom
                    anchors.horizontalCenter:parent.horizontalCenter
                }
            }

            Text {
                id:homeTeamScore
                text:scores.events[key].competitions[0].competitors[0].score
                color:Theme.textColor
                antialiasing : true
                font.pointSize:16
                width:25
                Layout.fillWidth:true
            }
        }

        Row {
            anchors.top:game.bottom
            topPadding:7

            Text {
                id:gameHeadline
                text:scores.events[key].competitions[0].hasOwnProperty("headlines") ? scores.events[key].competitions[0].headlines[0].shortLinkText : ""
                color:Theme.textColor
                font.pointSize:11
                antialiasing : true
                leftPadding:10
                width:root.width*.85
                Layout.fillWidth: true
                elide: Text.ElideRight
                wrapMode: Text.NoWrap
            }
        }
    }
    function gameState() {
        if (scores.events[key].competitions[0].status.type.state == "pre") {
            gameStatus.width=60
            return (Qt.formatDateTime(new Date(scores.events[key].competitions[0].date),"h:mm ap"));
        }
        else if (scores.events[key].competitions[0].status.type.state == "in") {
            gameStatus.width=35
            return (scores.events[key].competitions[0].status.period+getOrdinal(scores.events[key].competitions[0].status.period));
        }
        else {
             scores.events[key].competitions[0].status.type.detail.length > 5 ? gameStatus.width=35 : gameStatus.width=30
             return (scores.events[key].competitions[0].status.type.detail);
        }
    }

    property var initTimer:Timer{
        id: initTimer  // initial start find astros game
        interval: 600
        running: true
        repeat:  false
        onTriggered: {
            findKey();
        }
    }

    property var gameTimer: Timer{
        id: gameTimer
        interval: 1000*60*20 // 20 mins for game updates
        running: !scores.events[key].competitions[0].status.type.completed // is game over ?
        //scores.events[key].competitions[0].status.type.state // game started ?
        repeat:  true
        triggeredOnStart :true
        onTriggered: {
            getData(url1);
            initTimer.start()
        }
    }

    property var newgameTimer: Timer{
        id: newgameTimer
        interval: 1000*60*60*2  // 2 hours check for new game
        running: !gameTimer.running //true // is game over ?
        //scores.events[key].competitions[0].status.type.state // game started ?
        // in ->in progress
        // pre ->pre game
        // post -> completed
        repeat:  true
        onTriggered: {
            //if ( scores.events[key].competitions[0].status.type.state=="pre") {
            //        // game not running yet
            // }
            //else {
            getData(url1);
            initTimer.start()
            //}
        }
    }

    DataSource {
        id: timeSource
        engine: "time"
        connectedSources: ["Local"]
        interval: 1000*50 // delay 50 secs check again
        onNewData: {
            (Qt.formatTime(timeSource.data["Local"]["DateTime"],"h:mm") == Qt.formatDateTime(new Date(scores.events[key].competitions[0].date),"h:mm")) ?   gameTimer.start() : ""
            // currentTime < startTime ? refreshData : nothing
            // when currentTime > startTime no more updates until newGameTimer finds new game
        }
    }
}
