import QtQuick 2.9
import org.kde.plasma.core 2.1

Item {
    id:scoresMain
    width:420
    height:85

    //GetData{id:jsonData}

   function getOrdinal(n) {            // assigns superfix to inning
       var s=["th","st","nd","rd"],
       v=n%100;
       return (s[(v-20)%10]||s[v]||s[0]);
   }

   function refreshGameData () {
       jsonData.getData(jsonData.url2);
       jsonData.initTimer.start()
   }

    Rectangle {
        id:rect1
        width:scoresMain.width*.99
        height:85
        antialiasing : true
        color:"transparent"
        border.color:"transparent"
        radius:8
        anchors.top:scoresMain.top
        anchors.left:scoresMain.left
        anchors.leftMargin:2

        MouseArea {
            id: mouseArea1a
            anchors.fill: parent
            cursorShape:  Qt.PointingHandCursor
            hoverEnabled:true
            acceptedButtons: Qt.LeftButton | Qt.MiddleButton
            onEntered:parent.border.color=Theme.viewHoverColor
            onExited:parent.border.color="transparent"
            onClicked:(mouse.button==Qt.LeftButton) ? Qt.openUrlExternally(jsonData.gameboxScoresURL) : refreshGameData()
        }

        Image{
            id:atl
            source:jsonData.awayTeamLogo
            height:48
            width:48
            anchors.right:ateam.left
            anchors.top:rect1.top
            anchors.leftMargin:20
            anchors.rightMargin:20
            anchors.topMargin:10
        }

        Text {
            id:ateam
            text:jsonData.awayTeamAbrev
            color:"white"
            font.pointSize:16
            anchors.topMargin:10
            anchors.leftMargin:20
            anchors.rightMargin:20
            anchors.top:rect1.top
            anchors.right:ats.left

            Text {
                id:atr
                text:"("+jsonData.awayTeamRecord+")"
                color:"gray"
                font.pointSize:10
                antialiasing : true
                anchors.horizontalCenter:parent
                anchors.top:parent.bottom
            }
        }

        Text {
            id:ats
            text:jsonData.awayTeamScore
            color:"white"
            font.pointSize:16
            anchors.topMargin:10
            anchors.top:rect1.top
            anchors.right:gameStatus.left
            anchors.leftMargin:20
            anchors.rightMargin:30
        }

        Text {
            id:gameStatus
            text:jsonData.gameState()
            color:"white"
            anchors.topMargin:15
            anchors.top:rect1.top
            anchors.horizontalCenter:rect1.horizontalCenter

            Text {
                text:(jsonData.gameStatusState == "in") ? jsonData.gameClock : Qt.formatDateTime(new Date(jsonData.gameDate),"M/dd/yy")
                color:"gray"
                font.pointSize:10
                anchors.top:parent.bottom
                anchors.horizontalCenter:parent.horizontalCenter
            }
        }

        Text {
            id:hts
            text:jsonData.homeTeamScore
            color:"white"
            font.pointSize:16
            anchors.left:gameStatus.right
            anchors.top:rect1.top
            anchors.rightMargin:20
            anchors.leftMargin:30
            anchors.topMargin:10
        }

        Text {
            id:hta
            text:jsonData.homeTeamAbrev
            color:"white"
            font.pointSize:16
            anchors.topMargin:10
            anchors.leftMargin:20
            anchors.rightMargin:20
            anchors.top:rect1.top
            anchors.left:hts.right

            Text {
                text:"("+jsonData.homeTeamRecord+")"
                color:"gray"
                font.pointSize:10
                anchors.top:parent.bottom
                anchors.horizontalCenter:parent.horizontalCenter
            }
        }

        Image{
            id:htl
            source:jsonData.homeTeamLogo
            height:48
            width:48
            anchors.topMargin:10
            anchors.leftMargin:20
            anchors.rightMargin:20
            anchors.top:rect1.top
            anchors.left:hta.right
        }

        Text {
            anchors.bottom:rect1.bottom
            anchors.left:rect1.left
            anchors.bottomMargin:2
            text:jsonData.gameHeadline
            color:Theme.textColor
            font.pointSize:10
            antialiasing : true
            leftPadding:5
            width:rect1.width*.97
            elide: Text.ElideRight
            wrapMode: Text.NoWrap
        }
    }
}
