import QtQuick 2.9
import org.kde.plasma.core 2.1
import QtQuick.Layouts 1.15
import QtQuick.Controls 2.5
Item {
    id:stocks   // format stock data
    height:170

    property var finTitles:["DOW","NASDAQ","S&P 500","OIL","GOLD","10Y BOND"]

    function isPositive(num)
    {
        if(num < 0)
            return false;
        else
            return true;
    }

    Component {
        id: mrkts

        ColumnLayout { spacing:10; id:titles; Layout.alignment:Qt.AlignRight

            RowLayout {
                id:idx
                spacing:20
                Layout.leftMargin:10

                Text {
                    text:finTitles[index]
                    color:Theme.textColor
                    font.pointSize:14
                    Layout.leftMargin:20
                    Layout.preferredWidth:90
                    Layout.fillWidth:true
                    Layout.alignment:Qt.AlignRight
                    antialiasing : true
                }

                Text {
                    text:(jsonData.finClose[index]!="NA") ? isPositive(jsonData.finClose[index]-jsonData.finPrevClose[index])  ? "▲":"▼" : "▲"
                    color:(jsonData.finClose[index]!="NA") ? isPositive(jsonData.finClose[index]-jsonData.finPrevClose[index]) ? "green":"red" : "white"
                    font.pointSize:14
                    antialiasing : true
                    Layout.leftMargin:5
                    Layout.preferredWidth:10
                    Layout.fillWidth:true
                    horizontalAlignment: Text.AlignRight
                }


                Text {
                    text:(jsonData.finClose[index]!="NA") ? jsonData.formatNumber(jsonData.finClose[index]):"NA"
                    color:Theme.textColor
                    font.pointSize:14
                    antialiasing : true
                    Layout.leftMargin:1
                    Layout.preferredWidth:110
                    Layout.fillWidth:true
                    horizontalAlignment: Text.AlignRight
                }

                Text {
                    text:(jsonData.finClose[index]!="NA") ? jsonData.formatNumber((jsonData.finClose[index]-jsonData.finPrevClose[index]).toFixed(2)):"NA"
                    color:(jsonData.finClose[index]!="NA") ? isPositive(jsonData.finClose[index]-jsonData.finPrevClose[index]) ? "green":"red" : "white"
                    font.pointSize:14
                    antialiasing : true
                    font.bold:true
                    Layout.leftMargin:25
                    Layout.preferredWidth:75
                    Layout.fillWidth:true
                    horizontalAlignment: Text.AlignRight
                }
            }
        }
    }

    Item {
        id:mkt
        width:stocks.width
        height:stocks.height

        ListView {
            anchors.fill: parent
            model: 6
            delegate: mrkts
            spacing: 5
        }
    }
}
